[USACO14JAN]Recording the Moolympics

Posted Mrsrz

tags:

篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了[USACO14JAN]Recording the Moolympics相关的知识,希望对你有一定的参考价值。

题目:洛谷P2255。

题目大意:有n个节目,每个节目有开始和结束时间。有两台拍摄机,录制一个节目必须录制完整。求最多录制多少节目。

解题思路:贪心。由于$n\leq 150$,我们用$n^2$乱搞即可。

先按照节目结束时间从大到小排序,保证第一次找到的能拍摄的节目的结束时间最小(这样就可以拍摄更多的节目)。

然后,如果两台拍摄机都能拍摄,要用结尾时间较长的那台拍摄(因为这样另一台就可以拍摄更多的节目)。

为方便,我在第一台结束时间大于第二台结束时间时,就交换两台拍摄机。

时间复杂度$O(n^2)$。

C++ Code:

#include<cstdio>
#include<algorithm>
using namespace std;
int n;
struct olpk{
	int b,e;
	bool operator<(const olpk& rhs)const{
		if(e!=rhs.e)return e<rhs.e;
		return b<rhs.b;
	}
}a[155];
bool b[155]={0};
int main(){
	scanf("%d",&n);
	for(int i=1;i<=n;++i)scanf("%d%d",&a[i].b,&a[i].e);
	sort(a+1,a+n+1);
	int r1=0,r2=0,cnt=0;
	for(int i=1;i<=n;++i){
		for(int j=1;j<=n;++j)
		if(!b[j]){
			if(r1<=a[i].b){
				r1=a[i].e;
				++cnt;
				b[j]=true;
				break;
			}else
			if(r2<=a[i].b){
				r2=a[i].e;
				++cnt;
				b[j]=true;
				break;
			}
		}
		if(r1<r2)r1^=r2^=r1^=r2;
	}
	printf("%d\n",cnt);
	return 0;
}

 

以上是关于[USACO14JAN]Recording the Moolympics的主要内容,如果未能解决你的问题,请参考以下文章

[USACO14JAN]Recording the Moolympics

BZOJ 3433 [Usaco2014 Jan]Recording the Moolympics:贪心

1654: [Usaco2006 Jan]The Cow Prom 奶牛舞会

[BZOJ] 1634: [Usaco2007 Jan]Protecting the Flowers 护花

[BZOJ1634][Usaco2007 Jan]Protecting the Flowers 护花

洛谷 P2205 [USACO13JAN]画栅栏Painting the Fence